#!/bin/sh
#  Copyright (C) 2003-2010 Altair Engineering, Inc. All rights reserved.
# 
#  ALTAIR ENGINEERING INC. Proprietary and Confidential. Contains Trade Secret
#  Information. Not for use or disclosure outside ALTAIR and its licensed
#  clients. Information contained herein shall not be decompiled, disassembled,
#  duplicated or disclosed in whole or in part for any purpose. Usage of the
#  software is only as explicitly permitted in the end user software license
#  agreement.
# 
#  Copyright notice does not imply publication.

. ${PBS_CONF_FILE:-/etc/pbs.conf}

echo Setting placement set data ...
${PBS_EXEC}/bin/pbsnodes -a | grep "^[a-zA-Z]" | while read node
do
    if [ -n "`echo $node | grep 'r[0-9][0-9]*i[0-9]n[0-9][0-9]*'`" ]
    then
	L1=`echo $node | sed -e "s/\(r[0-9][0-9]*i[0-9][0-9]*\)n.*/\1/"`
	L2=`echo $node | sed -e "s/\(r[0-9][0-9]*\)i[0-9][0-9]*n.*/\1/"`
	echo "  for $node as resources_available.router=\"${L1},${L2}\""
	${PBS_EXEC}/bin/qmgr -c "s node $node resources_available.router=\"${L1},${L2}\""
    else
	echo " "
	echo Node ${node} name is not in standard SGI naming convention,
	echo no placement set created for ${node}
	echo " "
    fi

done
exit 0
