#!/bin/sh
#  Copyright (C) 2003-2010 Altair Engineering, Inc. All rights reserved.
# 
#  ALTAIR ENGINEERING INC. Proprietary and Confidential. Contains Trade Secret
#  Information. Not for use or disclosure outside ALTAIR and its licensed
#  clients. Information contained herein shall not be decompiled, disassembled,
#  duplicated or disclosed in whole or in part for any purpose. Usage of the
#  software is only as explicitly permitted in the end user software license
#  agreement.
# 
#  Copyright notice does not imply publication.

host=`/bin/hostname | sed -e 's/\..*//'`
ncpus=`cat /proc/cpuinfo | grep processor | wc -l | sed -e 's/ *//'`
memamt=`grep MemTotal: /proc/meminfo | sed -e 's/^MemTotal:[ 	]*//' | sed -e 's/ *[kK][bB]//'`

echo "\$configversion 2"
echo "$host: pnames = router"
echo "$host: resources_available.ncpus=$ncpus"
echo "$host: resources_available.mem=${memamt}kb"

if [ -n "$1" ] 
then
    if [ "$1" = "cpuset" ]
    then
	
#	create and write cpuset related information

	cpustr="0"
	i=1
	while [ $i -lt $ncpus ]
	do
	    cpustr="$cpustr,$i"
	    i=`expr $i + 1`
	done
	echo "$host: cpus = $cpustr"
	echo "$host: mems = 0"
	echo "$host: sharing = default_shared"
    else
	echo invalid argument to script $0
    fi
fi

exit 0
