#
#  Copyright (C) 2003-2010 Altair Engineering, Inc. All rights reserved.
# 
#  ALTAIR ENGINEERING INC. Proprietary and Confidential. Contains Trade Secret
#  Information. Not for use or disclosure outside ALTAIR and its licensed
#  clients. Information contained herein shall not be decompiled, disassembled,
#  duplicated or disclosed in whole or in part for any purpose. Usage of the
#  software is only as explicitly permitted in the end user software license
#  agreement.
# 
#  Copyright notice does not imply publication.
#
#
# Name:		PBS.pm
# Purpose:	Set up global PBS environment for Perl scripts
# Organization:	Altair Engineering, Inc.
# Contact:	pbssupport@altair.com
# Source:	None
#
# Comments:
#
# To do:
#  - Handle intelligently setting the PATH for Win32
#  - Ensure $ENV{PBS_CONF_FILE} is set
#

package PBS;

use strict;
use warnings;
use Cwd;

BEGIN {
  use Exporter ();
  our (@ISA, @EXPORT);

  @ISA = qw( Exporter );
  # PBS variables
  @EXPORT = qw( $PBS_ARCH $PBS_SITE $PBS_HOST $PBS_REV );
  # Common settings
  push @EXPORT, ( qw( $CLUSTER $DOMAIN @QUEUE @PACKAGES ) );
  # pbs-report settings
  push @EXPORT, ( qw( $LDAPBASE $LDAPDEPT $LDAPSRV ) );
}

our @EXPORT;

# Local variables
our $PBS_ARCH;
($PBS_ARCH = `uname -s`) =~ s/\n$//;
our $PBS_HOST;
($PBS_HOST = `uname -n`) =~ s/\n$//;
our $PBS_REV;
($PBS_REV = `uname -r`) =~ s/\n$//;

$ENV{PATH} = "/bin:/usr/bin:/sbin:/usr/sbin:/usr/bsd:/usr/local/bin:/usr/pbs/bin:/usr/apps/pbspro/bin";

# Common settings
our $CLUSTER = "PBS Pro Cluster";		# Name of the cluster for report headers
our $DOMAIN = "altair.com";			# Mail domain
our @PACKAGES = qw( abaqus ansys dyna fluent nastran opti starcd );

our @QUEUE = ();

# Site settings for accounting reports
#our $LDAPBASE = "o=MyCompany, c=US";		# LDAP query base
#our $LDAPDEPT = "deptcode";			# LDAP department code field
#our $LDAPSRV = "ldap.mycompany.com";		# LDAP server

1;
__END__
